#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t,n,k;

    cin>>t;
    cin>>n>>k;

    vector<int> a(n);

    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }




    sort(a.begin(),a.end());

    int mini=0, maxi=0;

    int cur=0;

    if(t==1)
    {

        if(n==k)
        {
            cout<<"DA\n";
            for(int i=0; i<n; i++)
            {
                cout<<a[i]<<" ";
            }
        }
        else
        {
            cout<<"NE\n";
        }

        /*for(int i=n-1; i>=0; i--)
        {

            if(mini<=a[i])
            {
                mini++;
            }
            else
            {
                mini--;
            }

        }

        for(int i=0; i<n; i++)
        {

            if(maxi<=a[i])
            {
                maxi++;
            }
            else
            {
                maxi--;
            }

        }


        if(k>=mini && k<=maxi)
        {

            bool lehet=false;

                do
                {
                    for(int i=0; i<n; i++)
                    {

                        if(cur<=a[i])
                        {
                            cur++;
                        }
                        else
                        {
                            cur--;
                        }

                    }
                    if(cur==k)
                    {
                        lehet=true;
                        cout<<"DA\n";
                        for(int i=0; i<n; i++)
                        {
                            cout<<a[i]<<" ";
                        }
                        break;
                    }
                }while(next_permutation(a.begin(),a.end()));

                if(!lehet)
                {
                    cout<<"NE\n";
                }
        }
        else
        {
            cout<<"NE\n";
        }*/






    }
    else
    {

        if(n==k)
        {
            cout<<"DA\n";

        }
        else
        {
            cout<<"NE\n";
        }

        /*for(int i=n-1; i>=0; i--)
        {

            if(mini<=a[i])
            {
                mini++;
            }
            else
            {
                mini--;
            }

        }

        for(int i=0; i<n; i++)
        {

            if(maxi<=a[i])
            {
                maxi++;
            }
            else
            {
                maxi--;
            }

        }

        if(k>=mini && k<=maxi)
        {

            bool lehet=false;

                do
                {
                    for(int i=0; i<n; i++)
                    {

                        if(cur<=a[i])
                        {
                            cur++;
                        }
                        else
                        {
                            cur--;
                        }
                    }

                    if(cur==k)
                    {
                        lehet=true;
                        cout<<"DA\n";

                        break;
                    }
                }while(next_permutation(a.begin(),a.end()));

                if(!lehet)
                {
                    cout<<"NE\n";
                }
        }
        else
        {
            cout<<"NE\n";
        }*/

    }



    return 0;
}